/* $Id: Interval.java,v 1.1.1.1 2017/03/30 23:49:44 mit3 Exp $ */	
/* Interval.java v2.3 (for jts) */
import java.awt.*;

public class Interval{
    private final int LWB = 0;
    private final int HIB = 1;
    private final int NAM = 2;
    private final int unison = 0;
    private final int i2nd = 1, j2nd = 2;
    private final int i3rd = 3, j3rd = 4;
    private final int p4th = 5, d5th = 6;
    private final int p5th = 7;
    private final int i6th = 8, j6th = 9;
    private final int i7th = 10,j7th = 11;
    private final int octave = 12;
    private final int tenth = 16, twelfth = 19;
    private final int octave2 = 24;
    private final int oct10th = 28, oct12th = 31;
    private final int octave3 = 36;
    private final int[] intnm = {
	unison,
	i2nd, j2nd, i3rd, j3rd,
	p4th, d5th, p5th,
	i6th, j6th, i7th, j7th,
	octave, octave, octave, //
	tenth, twelfth,
	octave2, oct10th, oct12th, octave3};
    private final String[] inter = {
	"unison",
	"mi.2nd","Mj.2nd","mi.3rd","Mj.3rd",
	"P.4th","Dim.5th","P.5th",
	"mi.6th","Mj.6th","mi.7th","Mj.7th",
	"Octave","Octave","Octave", //
	"10th","12th",
	"2octave","Oct.10th","Oct.12th","3octave"};
    final int[][] ratio = {                 // interval
	{1, 1, unison},
	{16, 15, i2nd},
	{9, 8, j2nd},
	{6, 5, i3rd},
	{5, 4, j3rd},
	{4, 3, p4th},
	{7, 5, d5th},
	{3, 2, p5th},
	{8, 5, i6th},
	{5, 3, j6th},
	{7, 4, i7th},
	{15, 8, j7th},
	{2, 1, octave}, {4, 2, octave}, {6, 3, octave}, // ɲ
	{5, 2, tenth},  {3, 1, twelfth},
	{4, 1, octave2},{5, 1, oct10th},
	{6, 1, oct12th},{8, 1, octave3}};

    public Interval() { }
    public int getInum() {
	return ratio.length;
    }
    public int[] getIratio(int v) {
	for (int i = 0; i < ratio.length; i++) {
	    if (ratio[i][NAM] == v) {
		int[] dt = {ratio[i][LWB], ratio[i][HIB], ratio[i][NAM]};
		return dt;
	    }
	}                       // inte -> [low high inte]
	return null;
    }
    public int getIinte(int v) {
	for (int i = 0; i < ratio.length; i++) {
	    if (ratio[i][NAM] == v)
		return i;
	}                       // inte -> inte (̵ͭΥå)
	return -1;
    }
    public String getIinter(int v) {
	v = Math.abs(v);
	for (int i = 0; i < intnm.length; i++) {
	    if (intnm[i] == v)
		return inter[i];
	}                       // inte -> ̾
	return "";
    }
    public String getIname(int n) {
	for (int i = 0; i < intnm.length; i++) {
	    if (ratio[n][NAM] == intnm[i])
		return inter[i];
	}                       // number -> ̾
	return "";
    }
    public int getIlow(int n) {
	return ratio[n][LWB];    // number -> low
    }
    public int getIhigh(int n) {
	return ratio[n][HIB];    // number -> high
    }
    public int getIvalue(int n) {
	return ratio[n][NAM];    // number -> inte
    }
    public int[] getIdata(int n) {
	int[] dt = new int[3];

	if (n < 0) {
	    n = -n;
	    dt[0] = ratio[n][HIB];
	    dt[1] = ratio[n][LWB];
	    dt[2] = -ratio[n][NAM];
	} else {
	    dt[0] = ratio[n][LWB];
	    dt[1] = ratio[n][HIB];
	    dt[2] = ratio[n][NAM];
	}

	return dt;                // number -> [low high inte]
    }
    public String toString(int n) {
	StringBuffer sb = new StringBuffer();
	sb.append(this.getIname(n)).append(" ");
	sb.append(ratio[n][LWB]).append(":");
	sb.append(ratio[n][HIB]);

	return sb.toString();
    }
}