/* $Id: ReadData.java,v 1.3 2017/04/21 08:34:09 mit3 Exp $
/* ReadData.java v0.1 */
import java.io.*;
import java.net.*;
import java.util.*;

public class ReadData {
    private static int AllD;
    private static int col = 2;
    private static KeyData[] D;
    private static String Error;
    private static BufferedReader bf;

    public ReadData(URL url) {
        Error = "";
        try {
            bf = new BufferedReader(new InputStreamReader(url.openStream()));
            this.readData();
        } catch (FileNotFoundException e1) {
            setError("File not found.");
        } catch (IOException e2) {
            setError("Can not Open.");
        }
    }
    public void close() {
        try {
            bf.close();
        } 
        catch (Exception e) {
            setError("c:"+e.toString());
        }
    }
    public void readData() {
        String line;
        String s[] = new String[col];
	D = new KeyData[88];
	int dataA = 0;
	double dataB = 0;
	AllD = 0;

        try {
            for (;;) {
                line = bf.readLine();
                if (line == null)
                    break;

                s = StoS(line);
                for (int i = 0; i < col; i++) {
		    if (i%2 == 0)
			dataA = Integer.parseInt(s[i]);
		    else
			dataB = Double.valueOf(s[i]).doubleValue();
		}

		D[AllD] = new KeyData(dataA, dataB);
		AllD++;
            }
            close();
        } catch (Exception e) {
            setError("w:"+e.toString());
        }
    }
    public String[] StoS(String val) {
        StringTokenizer tk = new StringTokenizer(val, " ");
	String temp[] = new String[col];
        int m = tk.countTokens();

        for (int i = 0; i < m; i++) {
            try {
                temp[i] = tk.nextToken();
            }
            catch (NoSuchElementException e) {
                setError("No Token.");
            }
            catch(NumberFormatException e) {
                setError("Data Read Error.");
            }
        }

        return temp;
    }
    public void setError(String text) {
        Error = text;
    }
    public static KeyData[] getData() {
        return D;
    }
    public static int getAllData() {
        return AllD;
    }
    public static String getError() {
        return Error;
    }
}
