/* $Id: jl.java,v 1.33 2017/07/29 23:00:54 mit3 Exp $
/* jl.java v0.1.2 */
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.text.DecimalFormat;

public class jl extends Applet
    implements ActionListener, AdjustmentListener, ItemListener,
	       MouseListener, MouseMotionListener
{
    final int KB = 88;
    final int OCTAVE = 12;
    final int CENT12 = 1200;
    final int PARTIAL = 21; // maxColor

    final int CENT = 0;
    //final int LAYI = 1;
    final int BEAT = 1;
    final int INHA = 2;

    final double REVOCT = 1.0/OCTAVE;
    final String[] Graph = {"Cent", "Beat", "Inha."}; // "Layi."
    final String[] Octnm = {"A2","A1","A","a","a1","a2","a3","a4"};
    final String[] KeyName =
    {"A..","B..","H..","C..","Cis","D..","Es.","E..","F..","Fis","G..","Gis"};
    final double[][] Adata = {    // I,G,H(88-49)
	{0.6413, 0.0973, 29.947}, // ai
	{0.6085, 0.0811, 10.341}, // ar
	{0.5986, 0.0833, 21.933}, // be
	{0.6261, 0.0892, 25.866}, // be1
	{0.5531, 0.0844, 19.646}, // ca
	{0.5797, 0.0881, 20.292}, // ci
	{0.6020, 0.0892, 30.782}, // co
	{0.6107, 0.0829, 36.782}, // cr
	{0.5913, 0.0820, 13.771}, // da
	{0.6058, 0.0888, 26.496}, // dn
	{0.5771, 0.0808, 23.937}, // fr
	{0.4988, 0.0775, 54.475}, // gi
	{0.4198, 0.0756, 26.429}, // gu
	{0.5870, 0.0831, 28.719}, // ha
	{0.6082, 0.0897, 22.202}, // iz
	{0.6138, 0.0837, 11.89},  // ka
	{0.6382, 0.0931, 23.274}, // ke
	{0.5829, 0.0912, 29.582}, // ko
	{0.6011, 0.0870, 31.152}, // ky
	{0.5952, 0.0885, 15.417}, // mi
	{0.6310, 0.0921, 21.115}, // po
	{0.6189, 0.0866, 17.897}, // ve
	{0.5994, 0.0887, 35.171}, // yu
	{0.6211, 0.0894, 29.697}, // zi
	{0.6389, 0.0910, 32.726}, // th ...25
	{0.6389, 0.0910, 34.293}, // ro ...26
	{0.5065, 0.0818, 12.358}, // da-mid ...27
	{0.5497, 0.0867, 34.295}, // da-osc ...28
    };
    private static final long serialVersionUID = 1L;

    private Button[] btGraph;
    private Button btPlus;
    private Button btMinus;
    private Button btAbs;
    private Button btRev;
    private Scrollbar scrA0, scrA1, scrA2, scrA3;
    private Label lbA0, lbA1, lbA2, lbA3;
    private Scrollbar scrA49I;
    private Scrollbar scrGrade;
    private Scrollbar scrGradeBass;
    private Scrollbar scrWound;
    private Label lbA49I;
    private Label lbGrade;
    private Label lbGradeBass;
    private Label lbWound;
    private List lstInterval;
    private TextField tfData;
    private Choice chA;
    private Canvas can;
    private Panel PN, PE, PW, PS;

    private Graphics gi;
    private Image ig;
    private Font Fnt;
    private FontMetrics fm;
    private DecimalFormat df1, df2;
    private Interval I;

    private int W, H, W2, H2;
    private int FONT;
    private int GRPH;
    private int WOUND = 28;
    private int DOT, SFT;
    private int Cmax, C2;
    private int Bmax;
    private int KEY = 49-1;
    private int AllF;
    private int AllData;
    private int CentCNT;

    private double DX, DY;
    private double HB;
    private double MouseX;
    private double MouseY;
    private double RR;
    private double A0, A1, A2, A3;
    private double A49I = 0.55;
    private double Grade = 0.087;
    private double GradeBass = 0.07;
    private double lsmA, lsmB;
    private String DirName;
    private String Error = "";
    private double[] Inha = new double[KB];
    private double[] Cent = new double[KB];
    private double[] XX = new double[4];
    private Color[] GC;
    private String[] FileName;
    private KeyData[] KD;
    private KeyData[] KdSort; 
    private boolean AbsSW;
    private boolean RevSW;
    private boolean MouseSW;

    public void init() {
        String fnt = getParameter("font");
        FONT = (fnt != null) ? Integer.parseInt(fnt) : 12;
        Fnt = new Font("SansSerif", Font.PLAIN, FONT);
        setFont(Fnt);
        fm = getFontMetrics(Fnt);
        df1 = new DecimalFormat("#0.0##");
	df2 = new DecimalFormat("0.00#####"); // for A4
        I = new Interval();

        buildLayout();

	initColor();
        Cmax = 80;
        Bmax = 20;

        GRPH = CENT;
	initInha();
	initCent();
	initA();
	initIGW();

	read_data(chA.getSelectedItem());
    }
    public void buildLayout() {
        setBackground(Color.lightGray);
        setLayout(new BorderLayout());

        PW = new Panel();
        PW.setLayout(new GridLayout(5,1,0,0));
        add(PW, "West");

        btGraph = new Button[Graph.length];
        for (int i = 0; i < Graph.length; i++) {
            btGraph[i] = new Button(Graph[i]);
            btGraph[i].addActionListener(this);
            PW.add(btGraph[i]);
        }
	//
        PE = new Panel();
        PE.setLayout(new GridLayout(4,1,0,0));
        add(PE, "East");

        btPlus = new Button("+");
        btPlus.addActionListener(this);
        PE.add(btPlus);

        btMinus = new Button("-");
        btMinus.addActionListener(this);
        PE.add(btMinus);

        btAbs = new Button("Abs.");
        btAbs.addActionListener(this);
        PE.add(btAbs);

        btRev = new Button("->");
        btRev.addActionListener(this);
        PE.add(btRev);
        //
        PN = new Panel();
        PN.setLayout(new FlowLayout());
        add(PN, "North");

	tfData = new TextField(26);
        tfData.setEditable(false);
        PN.add(tfData);

        int n = I.getInum();
        lstInterval = new List(1, true);
        for (int i = 0; i < n; i++) {
            lstInterval.add(I.toString(i));
        }
        lstInterval.select(5);  // 4th
        lstInterval.select(7);  // 5th
        lstInterval.select(12); // octave
        lstInterval.select(17); // 2octave
        lstInterval.addItemListener(this);
        PN.add(lstInterval);

	String fn = getParameter("allFile");
        AllF = (fn == null) ? 0 : Integer.parseInt(fn);
        if (AllF == 0)
            Error = "No wave file.";
        FileName = new String[AllF];  // max files  
        DirName = getParameter("dirnm");
        DirName = (DirName == null) ? "" : DirName;
	chA = new Choice();
	for (int i = 0; i < AllF; i++) {
            FileName[i] = getParameter("data"+i);
            chA.addItem(FileName[i]);
        }
        chA.addItemListener(this);
	PN.add(chA);
	//
        PS = new Panel();
        PS.setLayout(new GridLayout(4,4,0,0));
        add(PS, "South");

	scrA0 = new Scrollbar(Scrollbar.HORIZONTAL,500,1,0,1000);
        scrA0.addAdjustmentListener(this);
        PS.add(scrA0);

        lbA0 = new Label("A0: ", Label.LEFT);
        PS.add(lbA0);

	scrA49I = new Scrollbar(Scrollbar.HORIZONTAL,55,1,1,100);
	scrA49I.addAdjustmentListener(this);
	PS.add(scrA49I);

	lbA49I = new Label("A49I: ", Label.LEFT);
	PS.add(lbA49I);

	scrA1 = new Scrollbar(Scrollbar.HORIZONTAL,200,1,0,1000);
        scrA1.addAdjustmentListener(this);
        PS.add(scrA1);

        lbA1 = new Label("A1: ", Label.LEFT);
        PS.add(lbA1);

	scrGrade = new Scrollbar(Scrollbar.HORIZONTAL,87,1,1,110);
	scrGrade.addAdjustmentListener(this);
	PS.add(scrGrade);

	lbGrade = new Label("Grade: ", Label.LEFT);
	PS.add(lbGrade);

	scrA2 = new Scrollbar(Scrollbar.HORIZONTAL,500,1,0,1000);
        scrA2.addAdjustmentListener(this);
        PS.add(scrA2);

        lbA2 = new Label("A2: ", Label.LEFT);
        PS.add(lbA2);

	scrGradeBass = new Scrollbar(Scrollbar.HORIZONTAL,87,1,1,110);
	scrGradeBass.addAdjustmentListener(this);
	PS.add(scrGradeBass);

	lbGradeBass = new Label("GradeBass: ", Label.LEFT);
	PS.add(lbGradeBass);

	scrA3 = new Scrollbar(Scrollbar.HORIZONTAL,500,1,0,1000);
        scrA3.addAdjustmentListener(this);
        PS.add(scrA3);

        lbA3 = new Label("A3: ", Label.LEFT);
        PS.add(lbA3);

	scrWound = new Scrollbar(Scrollbar.HORIZONTAL,28,1,0,48);
	scrWound.addAdjustmentListener(this);
	PS.add(scrWound);

	lbWound = new Label("WoundW: ", Label.LEFT);
	PS.add(lbWound);
        //
        can = new myCanvas();
        add(can, "Center");

	can.addMouseListener(this);
        can.addMouseMotionListener(this);
    }
    public void start() {
        W = getCanvasD().width;
        H = getCanvasD().height;
        W2 = W/2;
        H2 = H/2;
        can.setSize(W, H);
        ig = createImage(W, H);
        gi = ig.getGraphics();
        gi.setFont(Fnt);

	DX = (double)W/KB;
	HB = H/10.0;
	initDot();
    }
    public Dimension getCanvasD() {
        Dimension dn = PN.getSize();
        Dimension de = PE.getSize();
        Dimension ds = PS.getSize();
        Dimension dw = PW.getSize();
        Dimension da = getSize();
        int cw = da.width-(de.width+dw.width);
        int ch = da.height-(dn.height+ds.height)-5;
        Dimension can = new Dimension(cw, ch);

        return can;
    }
    public String dform(double n) {
        return df1.format((float)n);
    }
    public String dform2(double n) {
        return df2.format((float)n);
    }
    public void initColor() {
        GC = new Color[PARTIAL];
        double dc = 1.0/PARTIAL;
        float c0;
        for (int i = 0; i < PARTIAL; i++) {
            c0 = (float)(dc*i);
            GC[i] = Color.getHSBColor(c0, 1.0f, 1.0f);
        }
    }
    public void initDot() {
        DOT = (int)((double)W/KB);
        if (DOT < 2)
            DOT = 2;

        SFT = DOT/2;
    }
    public void initCent() {
        for (int i = 0; i < KB; i++)
            Cent[i] = 0;
    }
    public void initInha() {
	for (int j = WOUND; j < KB; j++) {
	    Inha[j] = Math.exp(j * Grade);
	}
	double df = A49I / Inha[48];
	double db = (Inha[WOUND] * df) / make_bass_curve(WOUND);
	for (int i = 0; i < KB; i++) {
	    if (i <= WOUND)
		Inha[i] = make_bass_curve(i) * db;
	    else
		Inha[i] *= df;
	}
    }
    public double make_bass_curve(int key) {
	return cosh(GradeBass * (key - WOUND));
    }
    public double cosh(double x) {
	 double me = Math.pow(Math.E, x);

	 return (me+1/me) / 2;
    }
    //
    public void read_data(String file) {
        try {
            URL url = new URL(getDocumentBase(), DirName+file); //
            ReadData rd = new ReadData(url);

	    AllData = ReadData.getAllData();
	    KD = new KeyData[AllData];
	    KD = ReadData.getData();
	    Error = ReadData.getError();
        } catch(Exception e) {
            Error ="File read error.";
        }

	sortKey();
	selectData();
    }
    //
    public void mouseMoved(MouseEvent me) {
	if (MouseSW) {
            KEY = (int)(me.getX()/DX);
        }

	can.repaint();
    }
    public void mouseDragged(MouseEvent me) {}
    public void mousePressed(MouseEvent m) {
	MouseSW = !MouseSW;
	can.repaint();
    }
    public void mouseClicked(MouseEvent m) {}
    public void mouseReleased(MouseEvent m){}
    public void mouseEntered(MouseEvent m) {}
    public void mouseExited (MouseEvent m) {}
    //
    public void actionPerformed(ActionEvent e) {
        for (int i = 0; i < Graph.length; i++) {
            if (e.getSource() == btGraph[i]) {
                GRPH = i;
		if (GRPH == CENT) {
		    CentCNT++;
		    if (CentCNT > 3)
			CentCNT = 0;
		}
                break;
            }
        }
	if (e.getSource() == btPlus)
            set_gain(true);
        else if (e.getSource() == btMinus)
            set_gain(false);

        else if (e.getSource() == btAbs)
            set_abs();
        else if (e.getSource() == btRev)
            set_rev();

        can.repaint();
    }
    public void set_abs() {
        AbsSW = !AbsSW;
        btAbs.setLabel(AbsSW ? "abs." : "Abs.");
    }
    public void set_rev() {
        RevSW = !RevSW;
        btRev.setLabel(RevSW ? "<-" : "->");
    }
    public void set_gain(boolean sw) {
        switch (GRPH) {
        case CENT:
	    /*
	case LAYI:
            Cmax = sw ? Cmax*2 : Cmax/2;
            if (Cmax < 5)
                Cmax = 5;
            break;
	    */
        case BEAT:
            Bmax = sw ? Bmax*2 : Bmax/2;
            if (Bmax < 1)
                Bmax = 1;
            break;
        }
    }
    //
    public void adjustmentValueChanged(AdjustmentEvent e) {
        if (e.getSource() == scrA0)
            set_a0();
	if (e.getSource() == scrA1)
            set_a1();
        if (e.getSource() == scrA2)
            set_a2();
        if (e.getSource() == scrA3)
            set_a3();

	if (e.getSource() == scrA49I)
	    set_a49i();
	if (e.getSource() == scrGrade)
	    set_grade();
	if (e.getSource() == scrGradeBass)
	    set_gradeBass();
	if (e.getSource() == scrWound)
	    set_wound();

        can.repaint();
    }
    public void set_a0() {
	A0 = 10.0-scrA0.getValue()/10.0; //
       	calcCent();
    }
    public void set_a1() {
	A1 = scrA1.getValue()/100.0;
	calcCent();
    }
    public void set_a2() {
	A2 = -scrA2.getValue()/10000.0;
	calcCent();
    }
    public void set_a3() {
	A3 = scrA3.getValue()/1000000.0;
	calcCent();
    }
    public void calcCent() {
	for (int i = 0; i < KB; i++) {
	    Cent[i] = A0 + A1*i + A2*Math.pow(i, 2) + A3*Math.pow(i, 3);
	}

	textA();
    }
    public void initA() {
	set_a0();
	set_a1();
	set_a2();
	set_a3();

	textA();
    }
    public void set_a_scr() {
	int a0 = (int)(-A0*10);
	int a1 = (int)(A1*100);
	int a2 = (int)(-A2*10000);
	int a3 = (int)(A3*1000000);

	scrA0.setValue(a0);
	scrA1.setValue(a1);
	scrA2.setValue(a2);
	scrA3.setValue(a3);
    }
    public void textA() {
	lbA0.setText("A0: "+dform(A0));
	lbA1.setText("A1: "+dform(A1));
	lbA2.setText("A2: "+dform(A2));
	lbA3.setText("A3: "+dform2(A3));
    }
    public void set_a49i() {
	A49I = scrA49I.getValue()/100.0;
	initInha();
	lbA49I.setText("A49I: "+dform(A49I));
    }
    public void set_grade() {
	Grade = scrGrade.getValue()/1000.0;
	initInha();
	lbGrade.setText("Grade: "+dform(Grade));
    }
    public void set_gradeBass() {
	GradeBass = scrGradeBass.getValue()/1000.0;
	initInha();
	lbGradeBass.setText("GradeBass: "+dform(GradeBass)); 
    }
    public void set_wound() {
	WOUND = scrWound.getValue();
	initInha();
	lbWound.setText("WoundW: "+WOUND);
    }
    public void initIGW() {
	set_a49i();
	set_grade();
	set_gradeBass();
	set_wound();
    }
    // IG򥻥쥯Ϣư뤫?(1)
    public void set_ig_scr() {
	int a49i = (int)(A49I*100);
	int grade = (int)(Grade*1000);

	scrA49I.setValue(a49i);
	scrGrade.setValue(grade);
    }
    public void textIG() {
	lbA49I.setText("A49I: "+dform(A49I));
	lbGrade.setText("Grade: "+dform(Grade));
    }
    //
    public void itemStateChanged(ItemEvent e) {
	if (e.getItemSelectable() == chA) {
	    read_data(chA.getSelectedItem());
	}

	can.repaint();
    }
    public void selectData() {
	A0 = XX[1];
	A1 = XX[2];
	A2 = XX[3];
	A3 = XX[4];

	calcCent();
	textA();
	set_a_scr();
	// IGϢư?(2)
	int ind = chA.getSelectedIndex();
	A49I = Adata[ind][0];
	Grade = Adata[ind][1];
	initInha();
	textIG();
	set_ig_scr();
	//
    }
    //
    public void sortKey() {
	int k;
	int[] tmp = new int[KB+1];       // 1-88
	double[] val = new double[KB+1]; // "

	for (int i = 0; i < AllData; i++) { // ʬ
	    k = KD[i].getKey(); // lsm3ǻѤΰ٤ΤޤޤȤ
	    tmp[k]++;
	    val[k] += KD[i].getCent();
	}

	int cnt = 0;
	KdSort = new KeyData[KB]; // 0-87
	for (int l = 0; l < KB; l++) { // ʿͤФ
	    if (tmp[l] > 0) {
		KdSort[cnt] = new KeyData(l, val[l]/tmp[l]);
		cnt++;
	    }
	}

	lsm3(KdSort, cnt);
    }
    public void lsm3(KeyData[] kd, int S) {
	int n = 4; // n-1¿༰Ƕ
	int N = 4;
	int z = 0;
	double[][] A = new double[n+1][n+2];

	for (int l = 1; l <= n; l++) {
	    for (int j = 1; j <= n; j++) {
		for (int k = 0; k < S; k++) {
		    z = (l-1)+(j-1);
		    A[l][j] += Math.pow(kd[k].getKey(), z);
		}
	    }
	}

	for (int l = 1; l <= n; l++) {
	    for (int k = 0; k < S; k++) {
		A[l][n+1] += Math.pow(kd[k].getKey(), l-1)*kd[k].getCent();
	    }
	}

	XX = gauss(A, N);
    }
    public double[] gauss(double[][] a, int N) {
	double m;
	int pivot;

	for (int n = 1; n <= N; n++) {
	    m = 0;
	    pivot = n;

	    for (int l = n; l <= N; l++) {
		if (Math.abs(a[l][n]) > m) { // nǰͤ礭Ԥ
		    m = Math.abs(a[l][n]);
		    pivot = l;
		}
	    }

	    double[][] b = new double[N+1][N+2];
	    if (pivot != n) { // pivotnȰ㤨СԤؤ
		for (int j = 1; j <= N+1; j++) {
		    b[1][j] = a[n][j];
		    a[n][j] = a[pivot][j];
		    a[pivot][j] = b[1][j];
		}
	    }
	}

	double p, q;
	for (int k = 1; k <= N; k++) {
	    p = a[k][k]; //гǤ¸
	    a[k][k] = 1; //гǤϣˤʤ뤳Ȥ狼äƤ뤫

	    for (int j = k+1; j <= N+1; j++) {
		a[k][j] /= p;
	    }

	    for (int n = k+1; n <= N; n++) {
		q = a[n][k];

		for (int j = k+1; j <= N+1; j++) {
		    a[n][j] -= q*a[k][j];
		}
		a[n][k] = 0; //0Ȥʤ뤳Ȥ狼äƤȤ
	    }
	}
	double[] xx = new double[N+2];
	int j, n = N;
	while (n > 0) {
	    xx[n] = a[n][N+1];
	    j = N;
	    while (j > n) {
		xx[n] -= a[n][j]*xx[j];
		j--;
	    }
	    n--;
	}
	/*	
	System.out.println("\n");
	for (int i = 1; i <= N; i++) {
	    System.out.println(i+": "+xx[i] );
	}
	*/
	return xx;
    }
    //
    class myCanvas extends Canvas {
        private static final long serialVersionUID = 1L;
        public void update (Graphics g) {
            can.paint(g);
        }
        public void paint(Graphics g) {
            paintI();
            g.drawImage(ig, 0, 0, this);
        }
    }
    public void paintI() {
	bgBlack(gi);
        DY = (double)H/Cmax;
        C2 = Cmax/2;

        switch (GRPH) {
        case INHA:
            dispInha(gi);
            break;
        case CENT:
	    dispCline(gi);
	    dispAline(gi);
	    dispCentLine(gi);

	    dispData1(gi);
	    dispKdSort(gi);
	    dispCent(gi);
            break;
	    /*
	case LAYI:
	    dispCline(gi);
	    dispCentLine(gi);

	    dispLaying(gi);
	    break;
	    */
        case BEAT:
            dispBeat(gi);
            break;
        default:
            break;
        }
 
	write_tfdata();
    }
    public void write_tfdata() {
        StringBuffer sb = new StringBuffer(40);
        sb.append(getKeyname(KEY)+": ");
        sb.append(dform(calcFreq(1, KEY))+"[Hz]");

        switch (GRPH) {
        case INHA:
	    sb.append(": "+dform(Inha[KEY]));
            break;
        case CENT:
            sb.append(": "+dform(Cent[KEY]));
            sb.append("[cent]");
            break;
	    //case LAYI:
	    //
	    //break;
        case BEAT:
            //
            break;
	default:
        }

	String st = Error.equals("") ? sb.toString() : Error;
        tfData.setText(st);
    }
    public String getKeyname(int num) {
        return (num+1)+"("+getKey(num)+")";
    }
    public String getKey(int key) {
        return (key < 0) ? "" : KeyName[key%OCTAVE];
    }
    public void bgBlack(Graphics g) {
        g.setColor(Color.black);
        g.fillRect(0, 0, W, H);
    }
    //
    public void dispInha(Graphics g) {
        dispInhaLine(g);
        dispAline(g);

        for (int i = 0; i < KB; i++) {
	    mouseColor(g, i);
            g.fillOval((int)(i*DX),
                       (int)calc_inha(Inha[i]), DOT, DOT);
        }
    }
    public void mouseColor(Graphics g, int key) {
	if (key == KEY)
	    g.setColor(Color.green);
	else if (key <= WOUND)
	    g.setColor(Color.pink);
	else
	    g.setColor(Color.white);
    }
    public double calc_inha(double val) {
        return H2-Math.log(val)*HB;
    }
    public void dispInhaLine(Graphics g) {
        double h0 = 0.001, hl;
        double di = H/5.0;
        int hm;

        for (int i = 1; i < 6; i++) { // ʿ
            hl = h0*Math.pow(10, i);
            hm = (int)(SFT+H2-log_base(hl)*di);

            g.setColor(Color.blue);
            g.drawLine(0, hm, W, hm);

            g.setColor(Color.orange); // 
            g.drawString(""+(float)hl, 2, hm);
        }
    }
    public double log_base(double value) {
        return Math.log(value)/Math.log(10);
    }
    public void dispAline(Graphics g) {
        int x;

        for (int i = 0; i < KB; i += OCTAVE) {
            x = (int)(SFT+DX*i);

            g.setColor(Color.blue);
            g.drawLine(x, 0, x, H);

            g.setColor(Color.red);
            g.drawString(Octnm[i/OCTAVE], x, H-FONT);
        }
    }
    //
    public void dispCent(Graphics g) {
	if (CentCNT != 0 && CentCNT != 1)
	    return;

	g.setColor(Color.white);
	for (int i = 0; i < KB; i++) {
	    mouseColorCent(g, i);
	    g.fillOval((int)(i*DX), (int)(H2-Cent[i]*DY), DOT, DOT);
	}
	/* // centͷ׻
	System.out.println("c88: "+dform(Cent[87])+
			   " a49: "+dform(Cent[48])+
			   " height: "+dform(Cent[87]-Cent[48]) );
	*/
    }
    public void dispKdSort(Graphics g) {
	if (CentCNT != 3 && CentCNT != 1)
	    return;

	int k;
	double ce;

	g.setColor(Color.magenta);
	for (int i = 0; i < KB; i++) {
	    //System.out.println(i+" "+KdSort[i]);
	    if (KdSort[i] == null)
		continue;
	    k = KdSort[i].getKey()-1; // java˹碌 -1
	    ce = KdSort[i].getCent();
	    g.fillOval((int)(k*DX), (int)(H2-ce*DY), DOT, DOT);
	}
    }
    public void dispData1(Graphics g) {
	if (CentCNT != 2 && CentCNT != 1)
	    return;

	int k;
	double ce;

	g.setColor(Color.cyan);
	for (int i = 0; i < AllData; i++) {
	    k = KD[i].getKey()-1;
	    ce = KD[i].getCent();
	    g.fillOval((int)(k*DX), (int)(H2-ce*DY), DOT, DOT); 
	}
    }
    //
    public void mouseColorCent(Graphics g, int key) {
	if (key == KEY)
	    g.setColor(Color.green);
	else
	    g.setColor(Color.white);
    }
    public void dispCline(Graphics g) {
        g.setColor(Color.gray);
        g.drawLine(0, H2, W, H2);
    }
    public void dispCentLine(Graphics g) {
        int hp, hm, len, hx = C2/5;
        String str;
        double hy, hi;

        for (int i = 1; i < 6; i++) {
            hi = hx*i;
            hy = hi*DY;
            hp = (int)(SFT+H2+hy);
            hm = (int)(SFT+H2-hy);

            g.setColor(Color.darkGray);
            g.drawLine(0, hm, W, hm);
            g.drawLine(0, hp, W, hp);

            g.setColor(Color.pink);
            str = ""+hi;
            len = fm.stringWidth(str);
            g.drawString(str, W-len, hm+FONT);
            str = "-"+hi;
            len = fm.stringWidth(str);
            g.drawString(str, W-len, hp);
        }
    }
    //
    public void dispLaying(Graphics g) {
	int startK = 37-1;// 40:c 37:a 33:f 35:g 36:gs 39:h 38:b
	int endK = startK+3*OCTAVE+1;
	int keys = endK-startK;
	int ii, dot = 8;//, sft = dot/2;
	double dx = W/(double)keys;

	dispLayingLine(g, startK, endK);
	
	g.setColor(Color.white);
	for (int i = 0; i < keys; i++) {
	    ii = i+startK;
	    g.fillOval((int)(i*dx), (int)(H2-Cent[ii]*DY), dot, dot);
	}
	//System.out.println((float)(Cent[endK]-Cent[startK]));
	
	int k;
	double ce;
	int[] key = new int[KB];
	double[] cent = new double[KB];
	g.setColor(Color.magenta);
	for (int i = 0; i < KB ; i++) {
	    if (KdSort[i] == null)
		continue;

	    k = KdSort[i].getKey();
	    if (k >= startK && k < endK) {
		ii = k-startK;
		ce = KdSort[i].getCent();
		cent[k] = ce;
		key[k] = k;

		g.fillOval((int)(ii*dx), (int)(H2-ce*DY), dot, dot);
		//System.out.println(k+" "+ce+" "+ii);
	    }
	}
	/*
	calcLSM(key, cent);
	//System.out.println("lsmA: "+(float)lsmA+" lsmB: "+(float)lsmB);
	double y, dif;
	g.setColor(Color.yellow);
	for (int i = 0; i < keys; i++) {
	    y = lsmA+lsmB*(i+startK);
	    g.fillOval((int)(i*dx+sft), (int)(H2-y*DY), dot, dot);
	}
	dif = ((lsmA+lsmB*endK)-(lsmA+lsmB*startK));
	System.out.println((float)dif);
	*/
	/*
	g.setColor(Color.cyan);
	for (int i = 0; i < AllData; i++) {
	    k = KD[i].getKey()-1;
	    if (k >= startK && k < endK) {
		ce = KD[i].getCent();
		ii = k-startK;
		g.fillOval((int)(ii*dx+sft), (int)(H2-ce*DY), dot, dot);
	    }
	}
	*/
    }
    public void dispLayingLine(Graphics g, int startK, int endK) {
	int keys = endK-startK;
	int dh, sft = 8/2;//8*(1+1/2);
	double dx = W/(double)keys;

	for (int i = 0; i < keys; i++) {
	    dh = (int)(i*dx+sft);
	    g.setColor(Color.darkGray);
            g.drawLine(dh, 0, dh, H);

	    g.setColor(Color.orange);
	    g.drawString(getKey(i), dh, H-FONT);// f+8 c+3 a+0 h+2 g+10 b+1
	}
    }
    public void calcLSM(int[] key, double[] cent) {
        double s1 = 0, s2 = 0, xb = 0, yb = 0;
        double y, z;
        int x, n = 0;
	lsmA = 0;
	lsmB = 0;
	for (int i = 0; i < KB; i++) {
	    if (key[i] < 1)
		continue;
            x = i+1;
	    y = cent[i];

            s1 += x*y;
            s2 += x*x;
            xb += x;
            yb += y;
            n++;
        }
        s1 /= n;
        s2 /= n;
        xb /= n;
        yb /= n;
	z = s2-xb*xb;
	lsmA = (s2*yb-s1*xb)/z;
        lsmB = (s1-yb*xb)/z;
    }
    //
    public void dispBeat(Graphics g) {
        dispAline(g);
        dispBeatLine(g);

        int num, max;
	int[] inter = get_interval_list();
        double val;
        double db = AbsSW ? (double)H/Bmax : (double)H2/Bmax;
        int hh = AbsSW ? H : H2;
        Color mc;

        for (int j = 0; j < inter.length; j++) {
            num = inter[j];
            max = I.getIvalue(num);
            mc = GC[num];
            disp_beat_text(g, num, mc, j);
            for (int i = 0; i < KB; i++) {
		mouseColor(g, i, mc);
                if (RevSW) {
                    if (i < max)
                        continue;
                    val = getMbeats(i, -num, 1);
                } else {
                    if (i >= KB-max)
                        break;
                    val = getMbeats(i, num, 1);
                }
                val = AbsSW ? Math.abs(val) : val;
                g.fillOval((int)(i*DX), (int)(hh-val*db), DOT, DOT);

		if (i == KEY) {
                    g.setColor(Color.white);
                    g.drawString(dform(val), W2+4, FONT*(j+1));
                }
	    }
        }
    }
    public void mouseColor(Graphics g, int key, Color co) {
	if (key == KEY)
	    g.setColor(Color.white);
	else
	    g.setColor(co);
    }
    public int[] get_interval_list() {
        return lstInterval.getSelectedIndexes();
    }
    public void disp_beat_text(Graphics g, int n, Color c, int j) {
        String str = I.toString(n);
        int w0 = fm.stringWidth(str);
        g.setColor(c);
        g.drawString(str, W2-w0, FONT*(j+1));
    }
    public double getMbeats(int key, int inte, int mul) {
        int[] ratio = I.getIdata(inte); // -б
        int keyh = key+ratio[2];

        return get_mbeats(keyh, key, ratio, mul);
    }
    public double get_mbeats(int keyh, int keyl, int[] ratio, int mul) {
        return get_ibeats(keyh, keyl, calc_multi(ratio, mul));
    }
    public double get_ibeats(int keyh, int keyl, int[] ratio) {
        double fh = calcFreq(ratio[1], keyh);
        double fl = calcFreq(ratio[0], keyl);

        return (fh-fl);
    }
    public double calcFreq(int par, int key) {
        return ctof(getFreq(key)*par, getICent(key, par));
    }
    public double ctof(double f, double c) {
        return f*Math.pow(2, c/CENT12);
    }
    public double getFreq(int key) {
        return 440*Math.pow(2, (key-48)*REVOCT); // 49-1
    }
    public double getICent(int key, int par) {
        return Inha[key]*par*par+Cent[key];
    }
    public int[] calc_multi(int[] ratio, int mul) {
        int[] rat = new int[3];

        if (mul < 1) {
            System.out.println("*** Multi input error. ***");
            mul = 1;
        }
        rat[0] = ratio[0]*mul; // low
        rat[1] = ratio[1]*mul; // hi
        rat[2] = ratio[2];

        return rat;
    }
    public void dispBeatLine(Graphics g) {
        if (!AbsSW)
            dispCline(g);

        int hp = 0, hm, max = 5, xs = 2;
        int h2 = (AbsSW) ? H : H2;
        double hi, hv;
        double db = Bmax/(double)max;
        double dh = h2/(double)max;

        for (int i = 1; i < 6; i++) {
            hv = i*db;
            hi = i*dh;
            hm = (int)(SFT+h2-hi);
            if (!AbsSW)
		hp = (int)(h2+hi);

            g.setColor(Color.blue);
            g.drawLine(0, hm, W, hm);
            if (!AbsSW)
		g.drawLine(0, hp, W, hp);

            g.setColor(Color.yellow);
            g.drawString(dform(hv), xs+2, hm+FONT);
            if (!AbsSW)
                g.drawString("-"+dform(hv), xs, hp);
	}
    }
}
